-- Bloqwarrior!
-- Designed and Developed by Josuel Corporan Vargas

-- Font used for the text
  -- LCD Calculator
-- Color used to get rgb values in decimals
function fixColor(r,g,b,a)
  newR = r/255
  newG = g/255
  newB = b/255
  newA = a/255
  return {newR,newB,newB,newA}
end

-- Read the win number from the file called win data, and return the data in number form
function readScore()
  local score = love.filesystem.read("score.txt")
  return tonumber(score)
end

-- Write loss number with the loss number variable into the lossdata.sav
function writeScore(s)
  love.filesystem.write("score.txt",tostring(s))
end

function checkScoreExists()
  if not (love.filesystem.getInfo("score.txt")) then
    local FILE = love.filesystem.newFile("score.txt")
    FILE:open('w')
    FILE:write(0)
    FILE:close()
  end
end

function checkScore()
  if (readScore() == 0) then
    writeScore(0)
  end
end

-- Global amounts of hits
-- Lives of player
lives = 1
-- Global ball Speed
globalBallSpeed = 1
-- Range is the max number that will be used to see if it is equal to the number of current htius
range = 10
-- Range extension amount
range_extend_amt = 10
-- Amount of hits
hit_wait = 0
-- Max amount of hits
hit_wait_max = 3
-- Ball speed increase amt
speed_extend_amt = .5
-- Max time to wait for blocks to fall more
movetime_max = 3
local t,shakeDur,shakeMag = 0,-1,0
ENGAGE_BARRIER = false
--backgrounds_table = {love.graphics.newImage('nyc.jpg'),love.graphics.newImage('new-york-skyline.jpg'),love.graphics.newImage('effiel.jpg')}
-- Read the loss number from the file called loss data, and return the data in number form


function love.load()
  SCALE_UP = true
  SCALE_DOWN = false
  scaleX = 1
  scaleY = 1
  love.filesystem.setIdentity("screenshots")
  --checkScore()
  --checkScoreExists()
  checkScore()
  -- Score
  hscore_achieved = false
  hscore_showtext = false
  hscore_alert_time = 3
  score = 0
  backA = 0
  gameTypes = {'A','B'}
  gamemode = gameTypes[1]
  movingConditions = {true,true}
  isColliding = false
  loseColliding = false
  --highScore = 0
  highScore = math.floor(readScore())
  --checkNumbers()
  -- Set move paddle up/down var to false
  -- Signal to start the alert system
  alert_waitStart = false
  -- How long the alert message will last
  alert_wait_time = 2
  -- Texts shown on the top bar as an array
  texts = {"brickz", "a project68k game", "click to start!","press 1 to turn sound on/off","press 2 to turn music on/off","new ball added","ball lost","you lost","you got crushed"}
  -- Font name
  fontName = "sono.ttf"
  -- Index of text
  tIndex = 1
  -- This will define how long text will be shown on screen
  text_wait = 3
  -- Boolean that shows how long the screen will remain blank (Used on screen)
  waitStart = false
  -- Second boolean flag that indicates second waiting period (before the game ACTUALLY begins)
  secondWaitStart = false
  -- How long the player will wait before game begins
  second_wait_time = 3
  -- How long the screen will remain nothing (used for transitions)
  wait_time = 0.5
  -- Boolean that checks if the screen has been clicked
  
  
  PAUSED = false
  MOUSE_CLICKED = false
  sound_state = "on"
  -- Set of gamestates as an array
  gamestates = {"MENU","GAME","WAIT","LOST","INSTRUCTIONS","CREDITS","SPLASH","PREGAME"}
  -- Varaible state set to the initial gamestate
  state = gamestates[7]
  -- Boolean that indicates where the paddle moves up when collided
  move_up = false
  -- Boolean that indicates when paddle moves down when collided
  move_down = false
  -- Sounds
  collide_sound_1 = love.audio.newSource("gw11.dsp.wav","static")
  collide_sound_2 = love.audio.newSource("gw12.dsp.wav","static")
  move_sound = love.audio.newSource("gw04.dsp.wav","static")
  missed_sound = love.audio.newSource("ball_lost.mp3","static")
  loss_sound = love.audio.newSource("lost.wav","static")
  bong_sound = love.audio.newSource("bong.wav","static")
  game_start = love.audio.newSource("game_start.wav","static")
  getready = love.audio.newSource("getready.wav","static")
  new_ball = love.audio.newSource("ballpowerup.mp3","static")
  explosion_sound_1 = love.audio.newSource("explosion.wav","static")
  collide_sound_3 = love.audio.newSource("collideside.wav","static")
  selectsound = love.audio.newSource("pick.mp3","stream")
  choosesound = love.audio.newSource("select.mp3","stream")
  shoot_sound = love.audio.newSource("lasershoot.wav","static")
  powerup_1 = love.audio.newSource("powerup.wav","static")
  hscore_sound = love.audio.newSource("highscore.wav","static")
  -- Music
  mIndex = 1
  music_list = {love.audio.newSource("headspin.xm","stream"),love.audio.newSource("hammer.mod","stream"),love.audio.newSource("hip_hop_systeme_93.mod","stream"),love.audio.newSource("killer.it","stream"),love.audio.newSource("meandthebois.mod","stream"),love.audio.newSource("basketball.mod","stream"),love.audio.newSource("the_maniacs.mod","stream")}
  -- Calculator fonts used
  xLargeFont = love.graphics.newFont(fontName,48)
  largecalcFont = love.graphics.newFont(fontName,30)
  calcFont = love.graphics.newFont(fontName,20)
  smallCalcFont = love.graphics.newFont(fontName,20)
  xSmallCalcFont = love.graphics.newFont(fontName,13)
  --Font's filter set o nearest neighbor
  love.graphics.setDefaultFilter('nearest','nearest')
  largecalcFont:setFilter('nearest','nearest')
  calcFont:setFilter('nearest','nearest')
  smallCalcFont:setFilter('nearest','nearest')
  -- Block size is set to 16
  BRICK_SIZE = 16
  -- Bank (array) used to represent blocks on screen
  brickBank = {}
  --x_counter = 0
  --y_counter = 0
  -- X position of the
  -- Initial brick x position
  brickX = 0
  
  -- Each line of bricks will have a width and height
  brickWidth = (love.graphics.getWidth())
  brickHeight = BRICK_SIZE * (love.graphics.getHeight() / BRICK_SIZE)
  -- Initial line y position
  brickY = BRICK_SIZE * 2
  --upPaddle = {}
  --upPaddle.width = 56
  --upPaddle.height = 8
  --upPaddle.x = love.graphics.getWidth()/2 - upPaddle.width/2
  --upPaddle.y = BRICK_SIZE
  
  -- Down paddle's width and height
  downPaddle = {}
  downPaddle.width = 64
  downPaddle.height = 8
  
  
  -- topBar x and y, width and height
  topBar = {}
  topBar.x = 0
  topBar.y = 0
  
  topBar.width = love.graphics.getWidth()
  topBar.height = 32
  
  -- Width and height of a ball
  ballWidth = 8
  ballHeight = 8

  -- Initial paddle x and y position
  base_paddle_x = love.graphics.getWidth()/2 - downPaddle.width/2
  base_paddle_y = love.graphics.getHeight() - topBar.height - (BRICK_SIZE) - 8
  
  -- Assign downPaddle x and y position to base_paddle_x,y
  downPaddle.x = base_paddle_x
  downPaddle.y = base_paddle_y
  downPaddle.moveSpeed = 8
  -- Ball canvas table, each ball will be an 8 by 8 canvas with it's x and y, width, height, and initial x and y positions.
  ballCanvasTable = {{love.graphics.newCanvas(8,8),-3,-4,ballWidth,ballHeight,(downPaddle.x + downPaddle.width/2) - ballWidth/2,downPaddle.y - ballHeight * 2,0}}
  -- Powerup canvas table, each ball will be an 8 by 8 canvas with it's x and y, width, height, and initial x and y positions.
  --powerCanvasTable = {{love.graphics.newCanvas(8,8),-2,-3,ballWidth,ballHeight,(downPaddle.x + downPaddle.width/2) - ballWidth/2,downPaddle.y - ballHeight * 2}}
  -- Index counter used to indicate which object is used in canvasTable
  index_counter = 1
  -- Move time used indicate how long it will take for lines to fall
  moveTime = 3
  fallSpeed = 1
  -- Canvas that will be used to draw transparent bricks in the background
  backCanvas = love.graphics.newCanvas(brickWidth,brickHeight)
  -- Canvas Table used to store each brick
  canvasTable = {{brickX,brickY,BRICK_SIZE,{}}}
  -- Canvas for the UI
  
  -- Left bar canvas will be on the left side of the screen, and will have a width of 16 x 4, and the height will be scren height - topbarY + height (leaves space for the top bar)
  leftBarCanvas = love.graphics.newCanvas(BRICK_SIZE * 4,love.graphics.getHeight() - (topBar.y + topBar.height))
  -- Right bar canvas will be similar to the left bar, it will have a width of 16 x 4, same height as left Bar
  rightBarCanvas = love.graphics.newCanvas((BRICK_SIZE * 4),love.graphics.getHeight() - (topBar.y + topBar.height))
  --upPaddleCanvas = love.graphics.newCanvas(upPaddle.width,upPaddle.height)
  menuBarCanvas = love.graphics.newCanvas(love.graphics.getWidth(),BRICK_SIZE * 8)
  menuBarCanvas2 = love.graphics.newCanvas(love.graphics.getWidth(),BRICK_SIZE * 4)
  
  -- Paddle will also be a canvas
  downPaddleCanvas = love.graphics.newCanvas(downPaddle.width,downPaddle.height)
  
  -- Top bar canvas is created to be used to show the screen, and messages
  topBarCanvas = love.graphics.newCanvas(topBar.width,topBar.height)
  bottomBarCanvas = love.graphics.newCanvas(topBar.width,topBar.height)
  --getready:play()
  paddle_png = love.graphics.newImage("paddle.png")
  ball_png = love.graphics.newImage("ball.png")
  paddle_png:setFilter('nearest','nearest')
  ball_png:setFilter('nearest','nearest')
  --brick_png = love.graphics.newImage("brick.png")
  --brick_png:setFilter('nearest','nearest')
  
  colorChange = 0
  barrier = {}
  barrier.width = love.graphics.getWidth()
  barrier.height = 32
  barrier.x = 0
  barrier.y = base_paddle_y - 64
  engageTimer = 10
  engageShown = true
  engageShowTimer = 0.1
  spawnTime = 0
  
  menuComponents = {
    {'play',love.graphics.getWidth()/2 - largecalcFont:getWidth('play')/2,(love.graphics.getHeight()/2 - largecalcFont:getHeight('play')/2) - 32,gamestates[2]},
    {'instructions',love.graphics.getWidth()/2 - largecalcFont:getWidth('instructions')/2,(love.graphics.getHeight()/2 - largecalcFont:getHeight('instructions')/2) + 32,gamestates[7]},
    {'credits',love.graphics.getWidth()/2 - largecalcFont:getWidth('credits')/2,(love.graphics.getHeight()/2 - largecalcFont:getHeight('credits')/2) + 96,gamestates[6]}
  }
  
  instructComponents = {
    {'press left to move left',love.graphics.getWidth()/2 - xSmallCalcFont:getWidth('press left to move left')/2,(love.graphics.getHeight()/2 - xSmallCalcFont:getHeight('press left to move left')/2) - 64},
    {'press right to move right',love.graphics.getWidth()/2 - xSmallCalcFont:getWidth('press right to move right')/2,(love.graphics.getHeight()/2 - xSmallCalcFont:getHeight('press right to move right')/2) - 32},
    {'press up/down to move up/down',love.graphics.getWidth()/2 - xSmallCalcFont:getWidth('press up/down to move up/down')/2,(love.graphics.getHeight()/2 - xSmallCalcFont:getHeight('press up/down to move up/down')/2)},
    {'press enter to select',love.graphics.getWidth()/2 - xSmallCalcFont:getWidth('press enter to select')/2,(love.graphics.getHeight()/2 - xSmallCalcFont:getHeight('press enter to select')/2) + 32},
    {'press space to pause',love.graphics.getWidth()/2 - xSmallCalcFont:getWidth('press space to pause')/2,(love.graphics.getHeight()/2 - xSmallCalcFont:getHeight('press space to pause')/2) + 64},
    {'back',love.graphics.getWidth()/2 - xSmallCalcFont:getWidth('back')/2,(love.graphics.getHeight() - xSmallCalcFont:getHeight('back')) - 32}
  }
  

  pauseComponents = {
    {"PAUSED",love.graphics.getWidth()/2 - largecalcFont:getWidth("PAUSED")/2,(love.graphics.getHeight()/2 - largecalcFont:getHeight("PAUSED")/2) - 96},
    {"return",love.graphics.getWidth()/2 - largecalcFont:getWidth("return")/2,(love.graphics.getHeight()/2 - largecalcFont:getHeight("return")/2) + 32},
    {"quit",love.graphics.getWidth()/2 - largecalcFont:getWidth("quit")/2,(love.graphics.getHeight()/2 - largecalcFont:getHeight("quit")/2) + 96}
  }
  
  menuXtable = {
    {menuComponents[1][2],menuComponents[1][2] + (largecalcFont:getWidth(menuComponents[1][1]) - menuComponents[1][2])},
    {menuComponents[2][2],menuComponents[2][2] + (largecalcFont:getWidth(menuComponents[2][1]) - menuComponents[2][2])},
    {menuComponents[3][2],menuComponents[3][2] + (largecalcFont:getWidth(menuComponents[3][1]) - menuComponents[3][2])}
  }
  
  menuYtable = {
    (menuComponents[1][3] + (largecalcFont:getHeight(menuComponents[1][1]))) + 4,
    (menuComponents[2][3] + (largecalcFont:getHeight(menuComponents[2][1]))) + 4,
    (menuComponents[3][3] + (largecalcFont:getHeight(menuComponents[3][1]))) + 4
  }
  
  instructionsYtable = {
    (instructComponents[6][3] + (xSmallCalcFont:getHeight(instructComponents[6][1]))) + 4
  }
  
  creditsYtable = {
    (instructComponents[5][3] + (xSmallCalcFont:getHeight(instructComponents[5][1]))) + 4
  }
  pauseYTable = {
    (pauseComponents[2][3] + (largecalcFont:getHeight(pauseComponents[2][1]))) + 4,
    (pauseComponents[3][3] + (largecalcFont:getHeight(pauseComponents[3][1]))) + 4
  }
  
  creditComponents = {
    {'programmed by project68k',love.graphics.getWidth()/2 - xSmallCalcFont:getWidth('programmed by project68k')/2,(love.graphics.getHeight()/2 - xSmallCalcFont:getHeight('programmed by project68k')/2) - 64},
    {'sfx made with sfxr',love.graphics.getWidth()/2 - xSmallCalcFont:getWidth('sfx made with sfxr')/2,(love.graphics.getHeight()/2 - xSmallCalcFont:getHeight('sfx made with sfxr')/2) - 32},
    {'other sfx from pixabay',love.graphics.getWidth()/2 - xSmallCalcFont:getWidth('other sfx from pixabay')/2,(love.graphics.getHeight()/2 - xSmallCalcFont:getHeight('other sfx from pixabay')/2)},
    {'and game & watch',love.graphics.getWidth()/2 - xSmallCalcFont:getWidth('and game & watch')/2,(love.graphics.getHeight()/2 - xSmallCalcFont:getHeight('and game & watch')/2) + 32},
    {'music from mod archive',love.graphics.getWidth()/2 - xSmallCalcFont:getWidth('music from mod archive')/2,(love.graphics.getHeight()/2 - xSmallCalcFont:getHeight('music from mod archive')/2) + 64},
    {'back',love.graphics.getWidth()/2 - xSmallCalcFont:getWidth('back')/2,(love.graphics.getHeight() - xSmallCalcFont:getHeight('back')) - 32}
  }

  creditsYtable = {
    (creditComponents[6][3] + (xSmallCalcFont:getHeight(creditComponents[6][1]))) + 4
  }
  
  missles = {}
  missleSpawnTime = 0.5
  missleTimer = 10
  ENGAGE_MISSLES = false
  missleSpeed = 6
  menuSong = love.audio.newSource("verbal_reality.mp3","stream")
  selectionIndex = 1
  --menuImg = love.graphics.newImage("bg_img.png")
  --menuImg:setWrap("repeat","repeat")
  imgIndex = 1
  downPaddleSpeedMax = 14
  textX = love.graphics.getWidth()/2 - largecalcFont:getWidth(texts[1])/2
  textY = 0 - largecalcFont:getHeight(texts[1])
  textA = 1
  START_SPLASH_SOUND = false
  waitFadeBack = false
  missed_sound:setVolume(0.5)
  maxNumber = 128
  maxModulo = 16
end



-- Function used to check key presses for the 1 and 2 number, changing the music and sound status
function love.keypressed(key)
  if (key == "up") or (key == "w") and ((waitFadeBack == false) or (waitStart == false)) then
    if (selectionIndex > 1) then
      selectsound:stop()
      selectionIndex = selectionIndex - 1
      selectsound:play()
    end
  end
  
  if (key == "down") or (key == "s") and ((waitFadeBack == false) or (waitStart == false)) then
    if (state == gamestates[1]) then
      if (selectionIndex < 3) then
        selectsound:stop()
        selectionIndex = selectionIndex + 1
        selectsound:play()
      end
    end
    
    if (PAUSED == true) then
      if (selectionIndex < 2) then
        selectsound:stop()
        selectionIndex = selectionIndex + 1
        selectsound:play()
      end
    end
  end
  
  if (key == "return") and ((waitFadeBack == false) or (waitStart == false)) then
    if (state == gamestates[1]) then
      -- Set waitStart to true to begin the transition that blanks the screen
      choosesound:stop()
      if (selectionIndex == 1) then
        --menuSong:stop()
      end
      waitStart = true
      choosesound:play()
      collide_sound_3:play()
    elseif (state == gamestates[5]) or (state == gamestates[6]) then
      choosesound:stop()
      choosesound:play()
      waitStart = true
      collide_sound_3:play()
      --state = gamestates[1]
    --elseif (state == gamestates[7]) then
      --if (selectionIndex == 2) then
        --choosesound:play()
        --state = gamestates[1]
      --elseif (selectionIndex == 3) then
        --choosesound:play()
        --state = gamestates[1]
      --end
    end
    if (PAUSED) then
      if (selectionIndex == 1) then
        choosesound:stop()
        collide_sound_3:play()
        choosesound:play()
        love.audio.play(music_list[mIndex])
        PAUSED = false
      elseif (selectionIndex == 2) then
        waitStart = true
        choosesound:stop()
        collide_sound_3:play()
        choosesound:play()
        music_list[mIndex]:stop()
        -- Set mouse_clicked to false
        MOUSE_CLICKED = false
      end
    end
  end
  
  if (key == "space") and ((waitFadeBack == false) or (waitStart == false)) then
    if (state == gamestates[2]) then
      if (PAUSED == false) then
        love.audio.pause({music_list[mIndex]})
        choosesound:stop()
        choosesound:play()
        PAUSED = true
      end
    end
  end
  
      
end

-- Set volume for each sound effect
function setSoundVolume(num)
  collide_sound_1:setVolume(num)
  collide_sound_2:setVolume(num)
  move_sound:setVolume(num)
  missed_sound:setVolume(0.0)
  loss_sound:setVolume(num)
  bong_sound:setVolume(num)
  game_start:setVolume(num)
  getready:setVolume(num)
  new_ball:setVolume(num)
  menuSong:setVolume(num)
end

-- Set volume for each music
function setMusicVolume(num)
  for _,v in ipairs(music_list) do
    v:setVolume(num)
  end
end

-- Function to reset the game, used when the player has lost.
function resetGame()
  missleSpeed = 6
  selectionIndex = 1
  PAUSED = false
  isColliding = false
  text_wait = 3
  score = 0
  index_counter = 1
  moveTime = 3
  fallSpeed = 1
  move_up = false
  move_down = false
  -- Lives of player
  lives = 1
  -- Global ball Speed
  globalBallSpeed = 1
  -- Range is the max number that will be used to see if it is equal to the number of current htius
  range = 10
  -- Range extension amount
  range_extend_amt = 10
  -- Amount of hits
  hit_wait = 0
  -- Max amount of hits
  hit_wait_max = 3
  -- Ball speed increase amt
  speed_extend_amt = .5
  -- Max time to wait for blocks to fall more
  movetime_max = 3
  ballCanvasTable = {{love.graphics.newCanvas(8,8),-3,-4,ballWidth,ballHeight,(downPaddle.x + downPaddle.width/2) - ballWidth/2,downPaddle.y - ballHeight * 2}}
  canvasTable = {{brickX,brickY,BRICK_SIZE,{}}}
  downPaddle.x = base_paddle_x
  downPaddle.y = base_paddle_y
  downPaddle.moveSpeed = 8
  movingConditions = {true,true}
  ENGAGE_BARRIER = false
  engageTimer = 10
  engageShown = true
  engageShowTimer = 0.1
  spawnTime = 0
  missles = {}
  missleSpawnTime = 0.5
  missleTimer = 10
  ENGAGE_MISSLES = false
  hscore_achieved = false
  hscore_showtext = false
  hscore_alert_time = 3
end

-- Function to start the game (remakes the ballCanvasTable, and creates the first initial line for the canvasTable
function startGame()
  mIndex = math.ceil(love.math.random(1,#music_list))
  ballCanvasTable = {{love.graphics.newCanvas(8,8),-3,-4,ballWidth,ballHeight,(downPaddle.x + downPaddle.width/2) - ballWidth/2,downPaddle.y - ballHeight * 2}}
  if (gamemode == gameTypes[2]) then
    for x=canvasTable[index_counter][1],love.graphics.getWidth() - BRICK_SIZE,canvasTable[index_counter][3] do
      for y=canvasTable[index_counter][2],(BRICK_SIZE * 4),canvasTable[index_counter][3] do
      table.insert(canvasTable[index_counter][4],{x,y,canvasTable[index_counter][3],0,1,love.math.random(0,1),love.math.random(0,1),love.math.random(0,1)})
      end
    end
  else
    for x=canvasTable[index_counter][1],love.graphics.getWidth() - BRICK_SIZE,canvasTable[index_counter][3] do
      table.insert(canvasTable[index_counter][4],{x,canvasTable[index_counter][2],canvasTable[index_counter][3],0,1,love.math.random(0,1),love.math.random(0,1),love.math.random(0,1)})
    end
  end
end


-- Ball collision
function checkBallCollision()
  -- For each item in the ballCanvasTable
  for i,val in ipairs(ballCanvasTable) do
    --ball_x = val[6]
    --ball_y = val[7]
    --ball_width = val[1]:getWidth()
    --ball_height = val[1]:getHeight()
    --ball_xSpeed = val[2]
    --ball_ySpeed = val[3]
    
    -- For loop that goes through all the blocks falling down, and we do a collision check for the blocks and a list of balls, as well as the ball and the side of the screens and the paddle itself.
    for _,v in ipairs(canvasTable) do
      for j=1,#v[4] do
        -- THe collision checks will be done only if the ball and the brick are not nil items (meaning they don't exist)
        if not (v[4][j] == nil) and not (val == nil) then
          local block_x_pos = v[4][j][1]
          local block_y_pos = v[4][j][2]
          local block_width = v[4][j][3]
          local block_height = v[4][j][3]
          -- If the block is available.
          if (v[4][j][4] == 0) then
            -- Check collison between blocks and the ball
            if (val[6] <= block_x_pos + block_width and val[6] + val[1]:getWidth() >= block_x_pos) then
              if (val[7] <= block_y_pos + block_height  and val[7] + val[1]:getHeight() >= block_y_pos) then
                -- This if statement is the magic bullet that has been awaiting me for a few weeks. Prior to this, there were issues with the ball going throug blocks in an inaccurate way. During a college class, it came to me what the issue was. When the ball collides in the middle of two blocks, it will begin removing two blocks instead of one. In order to prevent this from happening, we need one more check, and that is to check if the center of the ball is less than the 
                --startShake(0.2,0.3)
                local randomNum  = love.math.random(1,500)
                if not (PAUSED == true) then
                  collide_sound_3:play()
                end
                if ((val[6] + val[1]:getWidth()) - (ballWidth/2) >= block_x_pos and (val[6] + val[1]:getWidth()) - (ballWidth/2) <= block_x_pos + block_width) or ((val[7] + val[1]:getHeight()) - (ballHeight/2) >= block_y_pos and (val[7] + val[1]:getHeight()) - (ballHeight/2) <= block_y_pos + block_height) then 
                -- scenario 1: (ball hits the bottom of the block)
                  if (val[7] <= block_y_pos + block_height and val[7] + val[1]:getHeight() > block_y_pos) then
                    --collide_sound_1:play()
                    --collide_sound_2:play()
                    explosion_sound_1:play()
                    -- Set the visibibility flag to 1 (meaning it has vanished)
                    v[4][j][4] = 1
                    -- Increase amount of hits
                    hit_wait = hit_wait + 1
                    -- If the amount of hits has exceeded or is equal to the max amount of allowed hits, it does the below
                    if (randomNum % 16 == 0) then
                      if (ENGAGE_BARRIER == false) then
                        if (spawnTime > love.math.random(5,20)) then
                          ENGAGE_BARRIER = true
                          powerup_1:play()
                        end
                      end
                    elseif (randomNum % 8 == 0) then
                      if (ENGAGE_MISSLES == false) then
                        if (spawnTime > love.math.random(5,20)) then
                          ENGAGE_MISSLES = true
                          table.insert(missles,{downPaddle.x + 4,downPaddle.y - 16,4,16})
                          table.insert(missles,{(downPaddle.x + downPaddleCanvas:getWidth()) - 8,downPaddle.y - 16,4,16})
                          powerup_1:play()
                        end
                      end
                    elseif (randomNum % 8 == 0) and (randomNum % 16 == 0) then
                      if (ENGAGE_MISSLES == false) and (ENGAGE_BARRIER == false) then
                        if (spawnTime > love.math.random(5,20)) then
                          local chooseNum = love.math.random(0,10)
                          if (chooseNum < 5) then
                            ENGAGE_BARRIER = true
                            powerup_1:play()
                          elseif (chooseNum > 5) then
                            ENGAGE_MISSLES = true
                            table.insert(missles,{downPaddle.x + 4,downPaddle.y - 16,4,16})
                            table.insert(missles,{(downPaddle.x + downPaddleCanvas:getWidth()) - 8,downPaddle.y - 16,4,16})
                            powerup_1:play()
                          end
                        end
                      end
                    end
                    
                            
                    if (love.math.random(1,maxNumber) % maxModulo == 0) then
                      alert_waitStart = true
                      alert_wait_time = 2
                      tIndex = 6
                      new_ball:stop()
                      new_ball:play()
                      missleSpeed = missleSpeed + .5
                      local powerup_id = 0
                      if (love.math.random(1,100) % 2 == 0) then
                        powerup_id = 1
                      elseif (love.math.random(1,100) % 4 == 0) then
                        powerup_id = 2
                      else
                        powerup_id = 0
                      end
                      -- Add a new ball to the ballCanvasTable
                      table.insert(ballCanvasTable,{love.graphics.newCanvas(8,8),val[2],val[3],ballWidth,ballHeight,val[6],val[7],love.math.random(0,2)})
                      -- Each new ball represents a life
                      lives = lives + 1
                      -- Sometimes the balls x or y speed will be considered negative or positive, so we add or subtract the speeds depending on what it will do.
                      if (val[3] < 0) then
                        val[3] = val[3] - speed_extend_amt
                      else
                        val[3] = val[3] + speed_extend_amt
                      end
                      if (downPaddle.moveSpeed < downPaddleSpeedMax) then
                        downPaddle.moveSpeed = downPaddle.moveSpeed + speed_extend_amt
                      end
                      -- add more max hits to the max hit
                      hit_wait_max = hit_wait_max + hit_wait_max
                      -- brick will fall faster now
                      if not (gamemode == gameTypes[2]) then
                        if (movetime_max > 1) then
                          movetime_max = movetime_max - .5
                        end
                      end
                        -- reset hit wait to 0
                      hit_wait = 0
                    end
                    -- set ball speed to inverted speed so it can richochet
                    val[3] = -val[3]
                    -- add 5 to the score
                    score = score + 5
                  end
                  
                  -- scenario 2: ball hits the top of a block
                  if (val[7] + val[1]:getHeight() >= block_y_pos and val[7] < block_y_pos) then
                    -- Play collision sounds
                    --collide_sound_1:play()
                    --collide_sound_2:play()
                    explosion_sound_1:play()
                    -- Set visibility flag for the block to be true
                    v[4][j][4] = 1
                    -- Increase amount of hits
                    hit_wait = hit_wait + 1
                    if (randomNum % 16 == 0) then
                      if (ENGAGE_BARRIER == false) and not (ENGAGE_MISSLES == true) then
                        if (spawnTime > love.math.random(5,20)) then
                          ENGAGE_BARRIER = true
                          powerup_1:play()
                        end
                      end
                    elseif (randomNum % 8 == 0) then
                      if (ENGAGE_MISSLES == false) and not (ENGAGE_BARRIER == true) then
                        if (spawnTime > love.math.random(5,20)) then
                          ENGAGE_MISSLES = true
                          table.insert(missles,{downPaddle.x + 4,downPaddle.y - 16,4,16})
                          table.insert(missles,{(downPaddle.x + downPaddleCanvas:getWidth()) - 8,downPaddle.y - 16,4,16})
                          powerup_1:play()
                        end
                      end
                    elseif (randomNum % 8 == 0) and (randomNum % 16 == 0) then
                      if (ENGAGE_MISSLES == false) and (ENGAGE_BARRIER == false) then
                        if (spawnTime > love.math.random(5,20)) then
                          local chooseNum = love.math.random(0,10)
                          if (chooseNum < 5) then
                            ENGAGE_BARRIER = true
                            powerup_1:play()
                          elseif (chooseNum > 5) then
                            ENGAGE_MISSLES = true
                            table.insert(missles,{downPaddle.x + 4,downPaddle.y - 16,4,16})
                            table.insert(missles,{(downPaddle.x + downPaddleCanvas:getWidth()) - 8,downPaddle.y - 16,4,16})
                            powerup_1:play()
                          end
                        end
                      end
                    end
                    
                    -- if the amount of hits is greater than or equal to max hits needed
                    if (love.math.random(1,maxNumber) % maxModulo == 0) then
                      -- Set the alert signal flag to true
                      alert_waitStart = true
                      -- Set the time to wait to 2
                      alert_wait_time = 2
                      -- Set text index to 4 (indicating a specific alert)
                      tIndex = 6
                      -- Play sound when new ball is created
                      new_ball:stop()
                      new_ball:play()
                      missleSpeed = missleSpeed + .5
                      local powerup_id = 0
                      if (love.math.random(1,100) % 2 == 0) then
                        powerup_id = 1
                      elseif (love.math.random(1,100) % 4 == 0) then
                        powerup_id = 2
                      else
                        powerup_id = 0
                      end
                      -- Add a new ball to the ballCanvasTable
                      table.insert(ballCanvasTable,{love.graphics.newCanvas(8,8),val[2],val[3],ballWidth,ballHeight,val[6],val[7],love.math.random(0,2)})
                      lives = lives + 1
                      -- The ball's y speed will decrease or increase depending on whether the ySpeed is negative or positive
                      if (val[3] < 0) then
                        val[3] = val[3] - speed_extend_amt
                      else
                        val[3] = val[3] + speed_extend_amt
                      end
                      if (downPaddle.moveSpeed < downPaddleSpeedMax) then
                        downPaddle.moveSpeed = downPaddle.moveSpeed + speed_extend_amt
                      end
                      -- Increase max amount of hits needed
                      hit_wait_max = hit_wait_max + hit_wait_max
                      -- Decrease the move time of the lines of brick to make it fall faster
                      if not (gamemode == gameTypes[2]) then
                        if (movetime_max > 1) then
                          movetime_max = movetime_max - .5
                        end
                      end
                        -- Reset hit_wait to 0
                      hit_wait = 0
                    end
                    -- Flip ball ySpeed velocity
                    val[3] = -val[3]
                    -- Increase score by 5
                    score = score + 5
                  end
                   -- scenario 3: ball hits the right side of the block
                  if (val[6] <= block_x_pos + block_width and val[6] + val[1]:getWidth() > block_x_pos + block_width) then
                    -- Play collision sounds
                    --collide_sound_1:play()
                    --collide_sound_2:play()
                    explosion_sound_1:play()
                    -- Set visibility flag for the block to be true
                    v[4][j][4] = 1
                    -- Increase amount of hits
                    hit_wait = hit_wait + 1
                    if (randomNum % 16 == 0) then
                      if (ENGAGE_BARRIER == false) and not (ENGAGE_MISSLES == true) then
                        if (spawnTime > love.math.random(5,20)) then
                          ENGAGE_BARRIER = true
                          powerup_1:play()
                        end
                      end
                    elseif (randomNum % 8 == 0) then
                      if (ENGAGE_MISSLES == false) and not (ENGAGE_BARRIER == true) then
                        if (spawnTime > love.math.random(5,20)) then
                          ENGAGE_MISSLES = true
                          table.insert(missles,{downPaddle.x + 4,downPaddle.y - 16,4,16})
                          table.insert(missles,{(downPaddle.x + downPaddleCanvas:getWidth()) - 8,downPaddle.y - 16,4,16})
                          powerup_1:play()
                        end
                      end                    
                    elseif (randomNum % 8 == 0) and (randomNum % 16 == 0) then
                      if (ENGAGE_MISSLES == false) and (ENGAGE_BARRIER == false) then
                        if (spawnTime > love.math.random(5,20)) then
                          local chooseNum = love.math.random(0,10)
                          if (chooseNum < 5) then
                            ENGAGE_BARRIER = true
                            powerup_1:play()
                          elseif (chooseNum > 5) then
                            ENGAGE_MISSLES = true
                            table.insert(missles,{downPaddle.x + 4,downPaddle.y - 16,4,16})
                            table.insert(missles,{(downPaddle.x + downPaddleCanvas:getWidth()) - 8,downPaddle.y - 16,4,16})
                            powerup_1:play()
                          end
                        end
                      end
                    end
                    
                    -- if the amount of hits is greater than or equal to max hits needed
                    if (love.math.random(1,maxNumber) % maxModulo == 0) then
                      -- Set the alert signal flag to true
                      alert_waitStart = true
                      -- Set the time to wait to 2
                      alert_wait_time = 2
                      -- Set text index to 4 (indicating a specific alert)
                      tIndex = 6
                      -- Play sound when new ball is created
                      new_ball:stop()
                      new_ball:play()
                      missleSpeed = missleSpeed + .5
                      local powerup_id = 0
                      if (love.math.random(1,100) % 2 == 0) then
                        powerup_id = 1
                      elseif (love.math.random(1,100) % 4 == 0) then
                        powerup_id = 2
                      else
                        powerup_id = 0
                      end
                      table.insert(ballCanvasTable,{love.graphics.newCanvas(8,8),val[2],val[3],ballWidth,ballHeight,val[6],val[7],love.math.random(0,2)})
                      lives = lives + 1
                      -- The ball's x speed will decrease or increase depending on whether the ySpeed is negative or positive
                      if (val[2] < 0) then
                        val[2] = val[2] - speed_extend_amt
                      else
                        val[2] = val[2] + speed_extend_amt
                      end
                      if (downPaddle.moveSpeed < downPaddleSpeedMax) then
                        downPaddle.moveSpeed = downPaddle.moveSpeed + speed_extend_amt
                      end
                      -- Increase max amount of hits needed
                      hit_wait_max = hit_wait_max + hit_wait_max
                      -- Decrease the move time of the lines of brick to make it fall faster
                      if not (gamemode == gameTypes[2]) then
                        if (movetime_max > 1) then
                          movetime_max = movetime_max - .5
                        end
                      end
                    
                      -- Reset hit_wait to 0
                      hit_wait = 0
                    end
                    -- Flip ball xSpeed velocity
                    val[2] = -val[2]
                    -- Increase score by 5
                    score = score + 5
                  end
                  -- scenario 4: ball hits the left side of the block
                  if (val[6] + val[1]:getWidth() >= block_x_pos and val[6] < block_x_pos) then
                    -- Play collision sounds
                    --collide_sound_1:play()
                    --collide_sound_2:play()
                    explosion_sound_1:play()
                    -- Set visibility flag for the block to be true
                    v[4][j][4] = 1
                    if (randomNum % 16 == 0) then
                      if (ENGAGE_BARRIER == false) and not (ENGAGE_MISSLES == true) then
                        if (spawnTime > love.math.random(5,20)) then
                          ENGAGE_BARRIER = true
                          powerup_1:play()
                        end
                      end
                    elseif (randomNum % 8 == 0) then
                      if (ENGAGE_MISSLES == false) and not (ENGAGE_BARRIER == true) then
                        if (spawnTime > love.math.random(5,20)) then
                          ENGAGE_MISSLES = true
                          table.insert(missles,{downPaddle.x + 4,downPaddle.y - 16,4,16})
                          table.insert(missles,{(downPaddle.x + downPaddleCanvas:getWidth()) - 8,downPaddle.y - 16,4,16})
                          powerup_1:play()
                        end
                      end                    
                    elseif (randomNum % 8 == 0) and (randomNum % 16 == 0) then
                      if (ENGAGE_MISSLES == false) and (ENGAGE_BARRIER == false) then
                        if (spawnTime > love.math.random(5,20)) then
                          local chooseNum = love.math.random(0,10)
                          if (chooseNum < 5) then
                            ENGAGE_BARRIER = true
                            powerup_1:play()
                          elseif (chooseNum > 5) then
                            ENGAGE_MISSLES = true
                            table.insert(missles,{downPaddle.x + 4,downPaddle.y - 16,4,16})
                            table.insert(missles,{(downPaddle.x + downPaddleCanvas:getWidth()) - 8,downPaddle.y - 16,4,16})
                            powerup_1:play()
                          end
                        end
                      end
                    end
          
                    -- Increase amount of hits
                    hit_wait = hit_wait + 1
                    -- if the amount of hits is greater than or equal to max hits needed
                    if (love.math.random(1,maxNumber) % maxModulo == 0) then
                      -- Set the alert signal flag to true
                      alert_waitStart = true
                      -- Set the time to wait to 2
                      alert_wait_time = 2
                      -- Set text index to 4 (indicating a specific alert)
                      tIndex = 6
                      -- Play sound when new ball is created
                      new_ball:stop()
                      new_ball:play()
                      local powerup_id = 0
                      missleSpeed = missleSpeed + .5
                      if (love.math.random(1,100) % 2 == 0) then
                        powerup_id = 1
                      elseif (love.math.random(1,100) % 4 == 0) then
                        powerup_id = 2
                      else
                        powerup_id = 0
                      end
                      table.insert(ballCanvasTable,{love.graphics.newCanvas(8,8),val[2],val[3],ballWidth,ballHeight,val[6],val[7],love.math.random(0,2)})
                      lives = lives + 1
                      -- The ball's x speed will decrease or increase depending on whether the ySpeed is negative or positive
                      if (val[2] < 0) then
                        val[2] = val[2] - speed_extend_amt
                      else
                        val[2] = val[2] + speed_extend_amt
                      end
                      if (downPaddle.moveSpeed < downPaddleSpeedMax) then
                        downPaddle.moveSpeed = downPaddle.moveSpeed + speed_extend_amt
                      end
                      -- Increase max amount of hits needed
                      hit_wait_max = hit_wait_max + hit_wait_max
                      -- Decrease the move time of the lines of brick to make it fall faster
                      if not (gamemode == gameTypes[2]) then
                        if (movetime_max > 1) then
                          movetime_max = movetime_max - .5
                        end
                      end
                      -- Reset hit_wait to 0
                      hit_wait = 0
                    end
                    -- Flip ball xSpeed velocity
                    val[2] = -val[2]
                    -- Increase score by 5
                    score = score + 5
                  end
                end
              end
            end
          end
          -- If the blocks y positon is greater than or equal to the screen height
          if (v[4][j][2] >= love.graphics.getHeight()) then
            -- If the block is not visible
            if (v[4][j][4] == 1) then
              -- We remove that block from the screen
              v[4][j] = nil
            end
          end
        end
      end
    end
    
    -- If the ball's x pos is less than or equal to the leftBar's x + width
    if (val[6] <= 0) then
      -- If the state is gamestate 2 (GAME)
      if (state == gamestates[2]) then
        -- play a sound
        --collide_sound_1:play()
        if not (PAUSED == true) then
          collide_sound_3:play()
        end
      end
      -- Flip ball x speed 
      val[2] = -val[2]
      val[6] = 0
    end
    
    -- If the ball's y pos is less than or equal to the topBar's y + height
    if (val[7] <= topBar.x + topBarCanvas:getHeight()) then
      -- If the state is gamestate 2 (GAME)
      if (state == gamestates[2]) then
        -- play a sound
        --collide_sound_1:play()
        if not (PAUSED == true) then
          collide_sound_3:play()
        end
      end
      -- Flip ball x speed 
      val[3] = -val[3]
      val[7] = topBar.x + topBarCanvas:getHeight()
    end
    
    -- If the ball's y pos + width is less than or equal to the rightBar's x + 
    if (val[6] + val[1]:getWidth() >= love.graphics.getWidth()) then
       -- If the state is gamestate 2 (GAME)
      if (state == gamestates[2]) then
        -- Play a sound
        --collide_sound_1:play()
        if not (PAUSED == true) then
          collide_sound_3:play()
        end
      end
      -- Flip ball x speed
      val[2] = -val[2]
      val[6] = (love.graphics.getWidth() - val[1]:getWidth())
    end
    
    -- If the state is equal to gamestate 2 (GAME)
    if (state == gamestates[2]) then
      -- AABB Collision (ball and downpaddle)
      if (val[6] <= downPaddle.x + downPaddleCanvas:getWidth() and val[6] + val[1]:getWidth() >= downPaddle.x) then
        if (val[7] <= downPaddle.y + downPaddleCanvas:getHeight() and val[7] + val[1]:getHeight() >= downPaddle.y) then
          -- Play sounds
          --collide_sound_1:play()
          if not (PAUSED == true) then
            bong_sound:play()
            collide_sound_3:play()
          end
          -- Flip the ball y speed
          val[3] = -val[3]
          val[7] = downPaddle.y - val[1]:getHeight()
          -- Set move_up to false, but move_down to true. This begins a small actions that allows the paddle to bounce a ball has collided with it
          move_up = false
          move_down = true
        end
      end
      

      -- AABB Collision (ball and barrier)
      if (ENGAGE_BARRIER == true) then
        if (val[6] <= barrier.x + barrier.width and val[6] + val[1]:getWidth() >= barrier.x) then
          if (val[7] <= barrier.y + barrier.height and val[7] + val[1]:getHeight() >= barrier.y) then
            -- Play sounds
            --collide_sound_1:play()
            if not (PAUSED == true) then
              bong_sound:play()
              collide_sound_3:play()
            end
            -- Flip the ball y speed
            val[3] = -val[3]
            val[7] = barrier.y - val[1]:getHeight()
            -- Set move_up to false, but move_down to true. This begins a small actions that allows the paddle to bounce a ball has collided with it
          end
        end
      end
    end
    
    -- If the ball's y pos + height is greater than or euqal to scren height
    if (val[7] + val[1]:getHeight() >= love.graphics.getHeight()) then
      -- If the state is gamestate 1 (MENU)
      if (state == gamestates[1]) then
        -- Simply flip the ball y speed
        val[3] = -val[3]
      else
        --startShake(1,0.5)
        -- Remove the ball from the equation
        table.remove(ballCanvasTable,i)
        -- Decrease lives
        lives = lives - 1
        --if (state == gamestates[2]) then
        -- Set alert_waitStart to true. This begins the point where an alert message appears on screen
        alert_waitStart = true
        -- Set 2 as the amount of time the player sees the message for.
        alert_wait_time = 2
        -- If the lives is greater than 0
        if (lives > 0) then
          -- Set textIndex to 5
          tIndex = 7
          -- Play a sound
          love.audio.stop(missed_sound)
          love.audio.play(missed_sound)
        else
          if (score > highScore) then
            writeScore(score)
            highScore = score
          end
          -- Set text index to 6
          tIndex = 8
          -- Play a sound
          love.audio.stop(missed_sound)
          love.audio.play(missed_sound)
          -- Stop music
          music_list[mIndex]:stop()
          -- Set state to gamestate 4 (LOST)
          state = gamestates[4]
        end
        --end
      end
    end
  end
end

function checkSidesPaddleCollision() 
  if (love.keyboard.isDown("left")) or (love.keyboard.isDown('a')) then
    if (movingConditions[1] == true) then
      movingConditions[2] = true
      if (downPaddle.x > 0) then
        if (movingConditions[1] == false) then
          movingConditions[1] = true
        end
        downPaddle.x = downPaddle.x - downPaddle.moveSpeed
      else
        downPaddle.x = 0
        movingConditions[1] = false
      end
    --elseif (movingConditions[1] == false) then
      --if (isColliding == false) then
        --movingConditions[1] = true
      --end
    end
  elseif (love.keyboard.isDown("right")) or (love.keyboard.isDown('d')) then
    if (movingConditions[2] == true) then
      movingConditions[1] = true
      if (downPaddle.x + downPaddleCanvas:getWidth() < love.graphics.getWidth()) then
        if (movingConditions[2] == false) then
          movingConditions[2] = true
        end
        downPaddle.x = downPaddle.x + downPaddle.moveSpeed
      else
        downPaddle.x = (love.graphics.getWidth() - downPaddleCanvas:getWidth())
        movingConditions[2] = false
      end
    --elseif (movingConditions[2] == false) then
      --if (isColliding == false) then
        --movingConditions[2] = true
      --end
    end
  end
end

function checkBrickMissleCollision()
  for _,v in ipairs(canvasTable) do
    for i,x in ipairs(missles) do
      for j=1,#v[4] do
        if not (v[4][j] == nil) then
          if (v[4][j][4] == 0) then
            if (v[4][j][1] <= x[1] + x[3] and v[4][j][1] + v[4][j][3] >= x[1]) and (v[4][j][2] <= x[2] + x[4] and v[4][j][2] + v[4][j][3] >= x[2]) then
              if not (PAUSED == true) then
                explosion_sound_1:play()
              end
              -- Set the visibibility flag to 1 (meaning it has vanished)
              score = score + 5
              v[4][j][4] = 1
              table.remove(missles,i)
            end
          end
        end
      end
    end
  end
end

              
function checkBrickBallCollision()
  for _,v in ipairs(canvasTable) do
    for j=1,#v[4] do
      if not (v[4][j] == nil) then
        if (v[4][j][4] == 0) then
          --if (v[4][j][2] + v[4][j][3] == downPaddle.y + downPaddleCanvas:getHeight()) then
            --if love.keyboard.isDown('left') then
          if (v[4][j][1] <= downPaddle.x + downPaddleCanvas:getWidth() and v[4][j][1] + v[4][j][3] >= downPaddle.x) and (v[4][j][2] <= downPaddle.y + downPaddleCanvas:getHeight() and v[4][j][2] + v[4][j][3] >= downPaddle.y) then
            local block_x = v[4][j][1]
            local block_y = v[4][j][2]
            local block_w = v[4][j][3]
            local block_h = v[4][j][3]
            isColliding = true
            if (downPaddle.x <= block_x + block_w and downPaddle.x + downPaddleCanvas:getWidth() >= block_x + block_w) then
              if ((block_x > downPaddle.x and block_x < downPaddle.x + downPaddleCanvas:getWidth()) or (block_x + block_w > downPaddle.x and block_x + block_w < downPaddle.x + downPaddleCanvas:getWidth())) then
                if (score > highScore) then
                  writeScore(score)
                  highScore = score
                end
                -- Set text index to 6
                tIndex = 9
                -- Play a sound
                love.audio.play(loss_sound)
                -- Stop music
                music_list[mIndex]:stop()
                -- Set state to gamestate 4 (LOST)
                state = gamestates[4]
                ENGAGE_BARRIER = false
                spawnTime = 0
              else
                downPaddle.x = block_x + block_w
                movingConditions[1] = false
              end
            end
                  
            if (downPaddle.x + downPaddleCanvas:getWidth() >= block_x and downPaddle.x <= block_x) then
              if ((block_x > downPaddle.x and block_x < downPaddle.x + downPaddleCanvas:getWidth()) or (block_x + block_w > downPaddle.x and block_x + block_w < downPaddle.x + downPaddleCanvas:getWidth())) then
                if (score > highScore) then
                  writeScore(score)
                  highScore = score
                end
                -- Set alert_waitStart to true. This begins the point where an alert message appears on screen
                alert_waitStart = true
                -- Set 2 as the amount of time the player sees the message for.
                alert_wait_time = 2
                -- Set text index to 8
                tIndex = 9
                -- Play a sound
                love.audio.play(loss_sound)
                -- Stop music
                music_list[mIndex]:stop()
                -- Set state to gamestate 4 (LOST)
                state = gamestates[4]
                ENGAGE_BARRIER = false
                spawnTime = 0
              else
                downPaddle.x = block_x - downPaddleCanvas:getWidth()
                movingConditions[2] = false
              end
            end
            

                  
                  
                  --if ((v[4][j][1] > downPaddle.x and v[4][j][1] < downPaddle.x + downPaddleCanvas:getWidth()) or (v[4][j][1] + v[4][j][3] > downPaddle.x and v[4][j][1] + v[4][j][3] < downPaddle.x + downPaddleCanvas:getWidth())) then
                    -- Set text index to 6
                    --tIndex = 8
                    -- Play a sound
                    --love.audio.play(loss_sound)
                    -- Stop music
                    --music_list[mIndex]:stop()
                    -- Set state to gamestate 4 (LOST)
                    --state = gamestates[4]
                  --end
          else
            isColliding = false
          end
          --end
        end
      end
    end
  end
end

-- Update function
function love.update(dt)
  
  if (state == gamestates[7]) then
    if (textY < love.graphics.getHeight()/2 - largecalcFont:getHeight(texts[1])/2) then
      textY = textY + 12
    end

    if (START_SPLASH_SOUND == true) and (getready:isPlaying() == false) then
      textA = textA - 2 * dt
        
      if (textA <= 0) then
        state = gamestates[1]
      end
    end
    
    if (START_SPLASH_SOUND == true) and (getready:isPlaying() == true) then
      if (SCALE_UP == true) then
        scaleX = scaleX + .1
        scaleY = scaleY + .1
      
        if (scaleX >= 1.6) and (scaleY >= 1.6) then
          SCALE_UP = false
          SCALE_DOWN = true
        end
      end
      
      if (SCALE_DOWN == true) then
        scaleX = scaleX - .1 
        scaleY = scaleY - .1
        
        if (scaleX <= 1) and (scaleY <= 1) then
          SCALE_DOWN = false
        end
      end
    end
      
    if (textY > love.graphics.getHeight()/2 - largecalcFont:getHeight(texts[1])/2) then
      textY = love.graphics.getHeight()/2 - largecalcFont:getHeight(texts[1])/2
      getready:play()
      START_SPLASH_SOUND = true
      
      
        
    end
  end
  
  --if (t < shakeDur) then
    --t = t + dt
  --end
  -- Function that renders things inside the backCanvas...canvas
  backCanvas:renderTo(
    function()
      -- Set color to black, but a lighter shade of it
      -- Clear screen
      love.graphics.clear()
      love.graphics.setColor(0,0,0,1)
      -- Begin to draw squares in the canvas
      --love.graphics.setBlendMode('alpha')
      -- For each BRICK_SIZE spot in the canvas, and up until x reaches the Width of the screen minus the brick size
      for x=0,backCanvas:getWidth(),BRICK_SIZE do
      --For each BRICK_SIZE spot in the canvas, and up until y reaches the height of the screen minus the brick size
        for y=0,backCanvas:getHeight(),BRICK_SIZE do
          -- Draw a 16 x 16 square.
          love.graphics.setColor(1,1,1,.10)
          love.graphics.rectangle("line",x,y,BRICK_SIZE,BRICK_SIZE)
        end
      end
      
      -- If the state is gamestate 1 (MENU)
      --if (state == gamestates[1]) then
        -- Set color to black
        --love.graphics.setColor(0,0,0,1)
        -- Set font to large calculator font
        --love.graphics.setFont(largecalcFont)
        -- Draw the text "sound" to the screen
        --love.graphics.print("sound",backCanvas:getWidth()/2 - largecalcFont:getWidth("sound")/2,64)
        -- Draw the status of the sound 
        --love.graphics.print(tostring(readSoundStatus()),backCanvas:getWidth()/2 - largecalcFont:getWidth(tostring(readSoundStatus()))/2,128)
        
        --love.graphics.print("high score",backCanvas:getWidth()/2 - largecalcFont:getWidth("high score")/2,(backCanvas:getHeight()/2 - largecalcFont:getHeight("high score")/2) - 32)
        -- Draw the score 
        --love.graphics.print("0",backCanvas:getWidth()/2 - largecalcFont:getWidth("0")/2,(backCanvas:getHeight()/2 - largecalcFont:getHeight("0")/2) + 32)
        -- Draw the text "music" to the screen
        --love.graphics.print("music",backCanvas:getWidth()/2 - largecalcFont:getWidth("music")/2,backCanvas:getHeight() - largecalcFont:getHeight("music") - 128)
        -- Draw the status of the music 
        --love.graphics.print(tostring(readMusicStatus()),backCanvas:getWidth()/2 - largecalcFont:getWidth(tostring(readMusicStatus()))/2,backCanvas:getHeight() - largecalcFont:getHeight(tostring(readMusicStatus())) - 64)
      --end
      
      -- If the state is gamestate 3 (WAIT)
      if (state == gamestates[3]) and (waitFadeBack == false) then
        -- Set color to black
        love.graphics.setColor(0,0,0,1)
        -- Set font to large calculator font
        love.graphics.setFont(largecalcFont)
        -- Draw ready text
        love.graphics.print("ready!",backCanvas:getWidth()/2 - largecalcFont:getWidth("ready!")/2,backCanvas:getHeight()/2 - largecalcFont:getHeight("ready!")/2)
      end
    end
  );
  
  --if not (state == gamestates[2]) and not (state == gamestates[3]) and not (state == gamestates[4]) and not (state == gamestates[7]) then
    --menuSong:play()
  --end
  -- As long as the state is gamestate 1 (MENU)
  if (state == gamestates[1]) then
    menuSong:play()
    -- Decreaste wait_time for text by 1
    --text_wait = text_wait - 1 * dt
    for _,v in ipairs(canvasTable) do
      for j=1,#v[4] do
        if not (v[4][j] == nil) then
          if (v[4][j][4] == 0) then
            --if (move_down == true) then
            v[4][j][5] = v[4][j][5] - 1 * dt
            
            if (v[4][j][5] <= 0) then
              v[4][j][6] = love.math.random(0,1)
              v[4][j][7] = love.math.random(0,1)
              v[4][j][8] = love.math.random(0,1)
              v[4][j][5] = 1
            end
            --end
          end
        end
      end
    end
    -- If the wait time for the text is less than or equal to 0
    --if (text_wait <= 0) then
      -- If the text index is less than 3
      --if (tIndex < 5) then
        -- Increase text index by 1
        --tIndex = tIndex + 1
      --else
        -- Set text index to 1
        --tIndex = 1
      --end
      --  Reset wait time for text to 3
      --text_wait = 3
    --end
  end
  
  -- If the waitStart is true, then we will begin a small transition
  
  if (waitFadeBack == true) then
    backA = backA - 4 * dt
    
    if (backA <= 0) then
      waitFadeBack = false
      --waitStart = false
      backA = 0
    end
  end
      
  if (waitStart == true) then
    --menuSong:stop()
    backA = backA + 4 * dt
    --if (wait_time > 0) then
      -- Decrease wait_time by 0.05
      --wait_time = wait_time - 0.05
    --end
      
    if (backA >= 1) then
      wait_time = 0.5
      waitStart = false
      waitFadeBack = true
      -- If the state is gamestate 4 (LOST)
      if (state == gamestates[4]) then
        -- Reset game
        resetGame()
        -- Set mouse_clicked to false
        MOUSE_CLICKED = false
        -- Set state to gamestate 1 (MENU)
        state = gamestates[1]
      elseif (state == gamestates[1]) then
        if (selectionIndex == 1) then
          -- Play sound
          menuSong:stop()
          --game_start:play()
          -- Start second waiting period
          secondWaitStart = true
          -- Set text index to 1
          tIndex = 1
          imgIndex = math.ceil(love.math.random(1,3))
          -- Set state to gamestate 3 (WAIT)
          state = gamestates[3]
        end
        if (selectionIndex == 2) then
          state = gamestates[5]
        end
        if (selectionIndex == 3) then
          state = gamestates[6]
        end
        
      elseif (state == gamestates[5]) then
        if (selectionIndex == 2) then
          state = gamestates[1]
        end
      elseif (state == gamestates[6]) then
        if (selectionIndex == 3) then
          state = gamestates[1]
        end
      elseif (state == gamestates[2]) then
        if (PAUSED == true) then
          resetGame()
          state = gamestates[1]
        end
      end
    end
  end
  
  -- This is the second waiting period (Done while the ready text is displayed)
  if (secondWaitStart == true) then
    if (second_wait_time > 0) then
      second_wait_time = second_wait_time - 1 * dt
    end
    if (second_wait_time <= 0) then
      -- Reset second wait time
      second_wait_time = 3
      -- Set secondWaitStart to false
      secondWaitStart = false
      -- Play sound
      move_sound:play()
      -- Start game
      startGame()
      -- Set state to gamestate 2 (GAME)
      state = gamestates[2]
    end
  end
  
  -- Used for alert messages
  if (alert_waitStart == true) then
    if (alert_wait_time > 0) then
      alert_wait_time = alert_wait_time - 1 * dt
    end
    
    if (alert_wait_time <= 0) then
      -- Reset alert_wait_time to 2
      alert_wait_time = 2
      -- Set alert_waitStart to false
      alert_waitStart = false
      -- Set textIndex to 1
      tIndex = 1
      -- If the state is equal to gamestate 4 (LOST)
      if (state == gamestates[4]) then
        -- Set waitStart to true
        waitStart = true
        -- Remove entire canvasTable
        table.remove(canvasTable)
      end
    end
  end
  
  -- This is used for adding lines of blocks to the screen, and moving down existing lines
  if (state == gamestates[2]) and (PAUSED == false) then
    if (music_list[mIndex]:isPlaying() == false) then
      mIndex = math.ceil(love.math.random(1,#music_list))
      music_list[mIndex]:play()
    end
    if (score > highScore) then
      if (hscore_achieved == false) then
        hscore_sound:play()
        hscore_showtext = true
        hscore_achieved = true
      end
    end
    
    if (hscore_showtext == true) then
      hscore_alert_time = hscore_alert_time - dt
      
      if (hscore_alert_time < 0) then
        hscore_alert_time = 3
        hscore_showtext = false
      end
    end
    menuSong:stop()
    if (ENGAGE_BARRIER == false) and (ENGAGE_MISSLES == false) then
      spawnTime = spawnTime + 1 * dt
    end
    if (ENGAGE_BARRIER == true) then
      engageTimer = engageTimer - 1 * dt
      spawnTime = 0
      if (engageTimer <= 0) then
        ENGAGE_BARRIER = false
        engageTimer = 10
        engageShowTimer = 0.1
        engageShown = true
      end
      
      if (engageTimer <= 5) then
        engageShowTimer = engageShowTimer - dt
        
        if (engageShowTimer <= 0) then
          engageShowTimer = 0.1
          if (engageShown == true) then
            engageShown = false
          else
            engageShown = true
          end
        end
      end
    end
    
    if (ENGAGE_MISSLES == true) then
      missleTimer = missleTimer - 1 * dt
      spawnTime = 0
      missleSpawnTime = missleSpawnTime - dt
      
      if (missleTimer <= 0) then
        ENGAGE_MISSLES = false
        missleTimer = 10
        missleSpawnTime = 0.5
      end
      
      if (missleSpawnTime < 0) then
        table.insert(missles,{downPaddle.x + 4,downPaddle.y - 16,4,16})
        table.insert(missles,{(downPaddle.x + downPaddleCanvas:getWidth()) - 8,downPaddle.y - 16,4,16})
        shoot_sound:play()
        missleSpawnTime = 0.5
        move_up = false
        move_down = true
      end
    end
      
    if not (gamemode == gameTypes[2]) then
      moveTime = moveTime - 1 * dt
      --if (NOT_RENDERED == false) then
      
      -- If the movieTime is less than 0
      if moveTime < 0 then
        -- Increase the index counter
        index_counter = index_counter + 1
        -- For each value in canvasTable
        for _,v in ipairs(canvasTable) do
          --v[2] = v[2] + BRICK_SIZE
          -- For j in v[4]
          for j=1,#v[4] do
            -- If the block exists
            if not (v[4][j] == nil) then
              -- Bring the existing blocks down to make way for the new ones
              v[4][j][2] = v[4][j][2] + BRICK_SIZE
            end
          end
        end
        -- Insert new info into the canvas table
        table.insert(canvasTable,index_counter,{brickX,brickY,BRICK_SIZE,{}})
        -- In the 4th entery in the CanvasTable object, add info about the blocks to be able to draw them later on at it's correct x and y position.
        for x=canvasTable[index_counter][1],love.graphics.getWidth() - BRICK_SIZE,canvasTable[index_counter][3] do
          table.insert(canvasTable[index_counter][4],{x,canvasTable[index_counter][2],canvasTable[index_counter][3],0,1,love.math.random(0,1),love.math.random(0,1),love.math.random(0,1)})
        end
        -- Play sound
        move_sound:play()
        moveTime = movetime_max
      end
    end
  end
  
  -- Check ball collison
  checkBallCollision()
  checkBrickMissleCollision()
  -- Render menuBarCanvas 
  menuBarCanvas:renderTo(
    function()
      love.graphics.clear()
      --love.graphics.setColor(1,1,1,1)
      --love.graphics.rectangle("fill",0,0,menuBarCanvas:getWidth(),menuBarCanvas:getHeight())
      love.graphics.setColor(0,0,0,1)
      love.graphics.setFont(largecalcFont)
      love.graphics.print(texts[1],menuBarCanvas:getWidth()/2 - largecalcFont:getWidth(texts[1])/2,menuBarCanvas:getHeight()/2 - largecalcFont:getHeight(texts[1])/2)
    end
    
  )
  
  -- Render menuBarCanvas2 
  menuBarCanvas2:renderTo(
    function()
      love.graphics.clear()
      --love.graphics.setColor(1,1,1,1)
      --love.graphics.rectangle("fill",0,0,menuBarCanvas2:getWidth(),menuBarCanvas2:getHeight())
      love.graphics.setColor(0,0,0,1)
      love.graphics.setFont(largecalcFont)
      love.graphics.print("best: "..tostring(highScore),menuBarCanvas2:getWidth()/2 - largecalcFont:getWidth("best: "..tostring(highScore))/2,menuBarCanvas2:getHeight()/2 - largecalcFont:getHeight("best: "..tostring(highScore))/2)
    end
    
  )
  -- Render topBarCanvas
  topBarCanvas:renderTo(
    function()
      love.graphics.clear()
      love.graphics.setColor(1,1,1,1)
      --love.graphics.setColor(0,0,0,1)
      love.graphics.rectangle("fill",0,0,topBarCanvas:getWidth(),topBarCanvas:getHeight())
      --love.graphics.setColor(1,1,1,.20)
      --for x=0,(topBarCanvas:getWidth() - (BRICK_SIZE)),BRICK_SIZE do
        --for y=0,(topBarCanvas:getHeight() - (BRICK_SIZE)),BRICK_SIZE do
          --love.graphics.rectangle('line',x,y,BRICK_SIZE,BRICK_SIZE)
        --end
      --end
      love.graphics.setColor(1,1,1,.50)
      --love.graphics.draw(backgrounds_table[2],0,menuBarCanvas:getHeight())
      --love.graphics.draw(menuImg,0,0,0)
      love.graphics.setColor(1,1,1,1)
      love.graphics.setColor(0,0,0,1)
      love.graphics.setFont(calcFont)
      love.graphics.print(texts[tIndex],topBarCanvas:getWidth()/2 - calcFont:getWidth(texts[tIndex])/2, topBarCanvas:getHeight()/2 - calcFont:getHeight(texts[tIndex])/2)
    end
  );
  
  -- Only if the state is equal to gamestate 2 (GAME), render the downPaddle
  if (state == gamestates[2]) then
    downPaddleCanvas:renderTo(
      function()
        love.graphics.clear()
        love.graphics.setColor(1,1,1,1)
        --love.graphics.setColor(0,0,0,1)
        
        if not (PAUSED == true) then
          love.graphics.draw(paddle_png,0,0)
        end
      end
    );
  end
    
  -- Render leftBarCanvas
  bottomBarCanvas:renderTo(
    function()
      love.graphics.clear()
      love.graphics.setColor(1,1,1,1)
      --love.graphics.setColor(0,0,0,1)
      love.graphics.rectangle("fill",0,0,bottomBarCanvas:getWidth(),rightBarCanvas:getHeight())
      --love.graphics.setColor(1,1,1,.20)
      --for x=0,(leftBarCanvas:getWidth() - (BRICK_SIZE)),BRICK_SIZE do
        --for y=0,(leftBarCanvas:getHeight() - (BRICK_SIZE)),BRICK_SIZE do
          --love.graphics.rectangle('line',x,y,BRICK_SIZE,BRICK_SIZE)
        --end
      --end
      love.graphics.setColor(1,1,1,.50)
      --love.graphics.draw(backgrounds_table[2],0,menuBarCanvas:getHeight())
      --love.graphics.draw(menuImg,0,0,0)
      love.graphics.setColor(1,1,1,1)
      love.graphics.setColor(0,0,0,1)
      love.graphics.setFont(calcFont)
      --if not (state == gamestates[1]) then
      if (hscore_showtext == true) then
        love.graphics.print("new high score!",bottomBarCanvas:getWidth()/2 - calcFont:getWidth("new high score!")/2,bottomBarCanvas:getHeight()/2 - calcFont:getHeight("new high score!")/2)
      else
        love.graphics.print("score: "..tostring(score),bottomBarCanvas:getWidth()/2 - calcFont:getWidth("score: "..tostring(score))/2,bottomBarCanvas:getHeight()/2 - calcFont:getHeight("score: "..tostring(score))/2)
      end
      --end
    end
  );
  
  -- Only if the state is NOT equal to gamestate 3 (WAIT)
  if not (state == gamestates[3]) and (PAUSED == false) then
    -- For each value in the ballCanvasTable
    for _,v in ipairs(ballCanvasTable) do
      --{{love.graphics.newCanvas(8,8),-2,-3,ballWidth,ballHeight,(downPaddle.x + downPaddle.width/2) - ballWidth/2,downPaddle.y - ballHeight}}
      -- If the item exists
      if not (v == nil) then
        -- Add the ball's x and y pos to the x and y speed
        if not (state == gamestates[4]) and not (state == gamestates[5]) and not (state == gamestates[6]) and not (state == gamestates[7]) then
          v[6] = v[6] + v[2]
          v[7] = v[7] + v[3]
        end
        
        -- Render each ball in it's own small canvas.
        v[1]:renderTo(
          function()
            love.graphics.clear()
            love.graphics.setColor(1,1,1,1)
            love.graphics.draw(ball_png,0,0)
          end
        );
      end
    end
    
    for _,v in ipairs(missles) do
      --if not (v == nil) then
      if not (state == gamestates[4]) then
        v[2] = v[2] - missleSpeed
      end
      --end
    end
  end
  
  -- If the state is equal to gamestate 2 (GAME)
  if (state == gamestates[2]) and (PAUSED == false) then
    -- Move the downPaddle X where the mouse X is, as long as the mosue X is greater than or equal to leftBar x + width, and less than rightBar x
    --if (love.mouse.getX() >= downPaddle.x) then
      --if (downPaddle.x >= (BRICK_SIZE* 4)) then
        --downPaddle.x = love.mouse.getX()
      --end
    --elseif (love.mouse.getX() <= downPaddle.x) then
      --if (downPaddle.x + downPaddleCanvas:getWidth() <= love.graphics.getWidth() - (BRICK_SIZE * 4)) then
        --downPaddle.x = love.mouse.getX()
      --end
    --end
    
    checkBrickBallCollision()
    checkSidesPaddleCollision()

    -- This is used for the paddle's bounce mechanism
    -- If the paddle has to move down
    if (move_down == true) then
      -- If the downPaddle y pos is less than the base_paddle y + 8
      if (downPaddle.y <= base_paddle_y + 10) then
        -- Increase downPaddle y pos by 1
        downPaddle.y = downPaddle.y + 1
      else
        -- Set downPaddle y to basePaddle y + 8, once it reaches that location
        downPaddle.y = base_paddle_y + 10
        -- Set move_down to false, but move_up to true. From this point, the paddle will being rapidly moving up
        move_down = false
        move_up = true
      end
      
      for _,v in ipairs(canvasTable) do
        for j=1,#v[4] do
          if not (v[4][j] == nil) then
            if not (v[4][j][4] == 1) then
              --if (move_down == true) then
              if (downPaddle.y + downPaddleCanvas:getHeight() >= v[4][j][2] and downPaddle.y + downPaddleCanvas:getHeight() <= v[4][j][2] + v[4][j][3]) then
                move_down = false
                move_up = true
              end
              --end
            end
          end
        end
      end
      
                
      
    end
    
    -- If the paddle has to move up
    if (move_up == true) then
      -- If the downPaddle y pos is greater than or equal to the base paddle's y pos
      if (downPaddle.y >= base_paddle_y) then
        -- Decrase down paddle y pos by 1
        downPaddle.y = downPaddle.y - 1
      else
        -- Set downPaddle y to base_paddle y
        downPaddle.y = base_paddle_y
        -- Set move_up to false, completing bounce mechanism
        move_up = false
      end
    end
  end
end

-- Love draw function
function love.draw()
  -- Set background color to white
  love.graphics.setBackgroundColor(1,1,1,1)
  --love.graphics.print(tostring(isColliding),20,50)
  --love.graphics.print(tostring(loseColliding),20,100)
  -- If the waitStart is false (SCREEN not blank
  --if (waitStart == false) then
    --if (t < shakeDur) then
      --local dx = love.math.random(-shakeMag,shakeMag)
      --local dy = love.math.random(-shakeMag,shakeMag)
      --love.graphics.translate(dx,dy)
    --end
    -- Draw back canvas
    --love.graphics.setColor(0,0,1,.10)
    love.graphics.setColor(1,1,1,1)
    if (state == gamestates[1]) then
      love.graphics.setColor(1,1,1,.50)
      --love.graphics.draw(backgrounds_table[2],0,menuBarCanvas:getHeight())
      --love.graphics.draw(menuImg,love.graphics.getWidth()/2 - menuImg:getWidth()/2,love.graphics.getHeight()/2 - menuImg:getHeight()/2,0)
      love.graphics.setColor(1,1,1,1)
      love.graphics.draw(menuBarCanvas,0,0)
      love.graphics.draw(menuBarCanvas2,0,love.graphics.getHeight() - menuBarCanvas2:getHeight())
      love.graphics.setFont(largecalcFont)
      for _,v in ipairs(menuComponents) do
        love.graphics.setColor(0,0,0,1)
        love.graphics.print(v[1],v[2],v[3])
      end
      love.graphics.setColor(0,0,0,1)
      love.graphics.rectangle("fill",menuComponents[selectionIndex][2],menuYtable[selectionIndex],largecalcFont:getWidth(menuComponents[selectionIndex][1]),4)
    end
    
    if not (state == gamestates[1]) and not (state == gamestates[5]) and not (state == gamestates[6]) and not (state == gamestates[7]) and not (PAUSED == true) then
      love.graphics.setColor(1,1,1,.50)
      --slove.graphics.draw(backgrounds_table[imgIndex],0,0)
      love.graphics.setColor(1,1,1,1)
    end
    
    if (state == gamestates[5]) or (state == gamestates[6]) and not (state == gamestates[7])  then
      love.graphics.setColor(1,1,1,.50)
      --love.graphics.draw(backgrounds_table[2],0,menuBarCanvas:getHeight())
      --love.graphics.draw(menuImg,love.graphics.getWidth()/2 - menuImg:getWidth()/2,love.graphics.getHeight()/2 - menuImg:getHeight()/2,0)
      love.graphics.setColor(1,1,1,1)
    end
    -- Draw the top bar.
    love.graphics.setColor(1,1,1,1)

    -- For each item in the canvasTable

    -- If the state is equal to gamestate 2 (GAME) or the state is equal to gamestate 4 (LOST)
    --if (state == gamestates[2]) or (state == gamestates[4]) then
      -- Draw canvas containing paddle
      --love.graphics.draw(downPaddleCanvas,downPaddle.x,downPaddle.y)
    --end
    
    -- If the state is equal to gamestate 2 (GAME) or the state is equal to gamestate 4 (LOST)
    --love.graphics.setColor(0,0,1,1)
    love.graphics.setColor(1,1,1,1)
    if (state == gamestates[2]) or (state == gamestates[4]) and not (state == gamestates[7]) then
      -- Draw canvas containing paddle
      love.graphics.draw(downPaddleCanvas,downPaddle.x,downPaddle.y)
    end
    
    for _,v in ipairs(canvasTable) do
      --for x=v[1],(love.graphics.getWidth() - (BRICK_SIZE * 4)) - BRICK_SIZE,v[3] do
        --love.graphics.rectangle("fill",x,v[2],v[3],v[3])
      --end
      -- Set color to black
      -- For each value in v[4]
      for j=1,#v[4] do
        -- If the item has been created, or currently exists with it's coordinates and info
        if not (v[4][j] == nil) then
          if (v[4][j][4] == 0) then
            if not (PAUSED == true) then
              -- Draw block with the coordinates saved prior
              love.graphics.setColor(0,0,0,1)
              love.graphics.rectangle("fill",v[4][j][1],v[4][j][2],v[4][j][3],v[4][j][3])
              love.graphics.setColor(0,0,0,1)
              --love.graphics.rectangle("line",v[4][j][1],v[4][j][2],v[4][j][3],v[4][j][3])
              --love.graphics.setColor(0,0,0,1)
              --love.graphics.line(v[4][j][1],v[4][j][2] + v[4][j][3]/2 - 3,v[4][j][1] + v[4][j][3],v[4][j][2] + v[4][j][3]/2 - 3)
              --love.graphics.line(v[4][j][1],v[4][j][2] + v[4][j][3]/2 + 3,v[4][j][1] + v[4][j][3],v[4][j][2] + v[4][j][3]/2 + 3)
              --love.graphics.line((v[4][j][1] + (v[4][j][3])/2) - 3,(v[4][j][2] + v[4][j][3]/2) - 3,(v[4][j][1] + (v[4][j][3])/2) - 3,(v[4][j][2] + v[4][j][3]/2) + 3)
              --love.graphics.line((v[4][j][1] + (v[4][j][3])/2) + 3,(v[4][j][2] + v[4][j][3]/2) - 3,(v[4][j][1] + (v[4][j][3])/2) + 3,(v[4][j][2] + v[4][j][3]/2) + 3)
              --love.graphics.line((v[4][j][1] + (v[4][j][3])/2),v[4][j][2],(v[4][j][1] + (v[4][j][3])/2),(v[4][j][2] + v[4][j][3]/2) - 3)
              --love.graphics.line((v[4][j][1] + (v[4][j][3])/2),v[4][j][2] + v[4][j][3]/2 + 3,(v[4][j][1] + (v[4][j][3])/2),v[4][j][2] + v[4][j][3])
              --love.graphics.draw(brick_png,v[4][j][1],v[4][j][2])
            end
          end
        end
      end
    end
    --love.graphics.draw(upPaddleCanvas,upPaddle.x,upPaddle.y)
    -- Draw left bar canvas
    --love.graphics.setColor(1,0,0,1)
    -- If the state is NOT equal to gamestate[3] (WAIT)
    if not (state == gamestates[3]) and not (state == gamestates[1]) and not (state == gamestates[5]) and not (state == gamestates[6]) and not (state == gamestates[7]) and not (PAUSED == true) then
      -- For each value in ballCanvasTable
      for _,v in ipairs(ballCanvasTable) do
        --{{love.graphics.newCanvas(8,8),-2,-3,ballWidth,ballHeight,(downPaddle.x + downPaddle.width/2) - ballWidth/2,downPaddle.y - ballHeight}}
        -- If the value is not nil (deleted)
        if not (v == nil) then
          -- Draw the canvas containing the bar
          love.graphics.setColor(1,1,1,1)
          love.graphics.draw(v[1],v[6],v[7])
        end
      end
    end
    
    if (state == gamestates[2]) then
      if (ENGAGE_BARRIER == true) then
        if (engageShown == true) and not (PAUSED == true) then
          love.graphics.setColor(0,0,0,1)
          love.graphics.rectangle("fill",barrier.x,barrier.y,barrier.width,barrier.height)
        end
      end
      
      if not (PAUSED == true) then
        for _,v in ipairs(missles) do
          love.graphics.setColor(0,0,0,1)
          love.graphics.rectangle("fill",v[1],v[2],v[3],v[4])
        end
      end
    end
    
    if (state == gamestates[5]) then
      love.graphics.setColor(0,0,0,1)
      love.graphics.setFont(largecalcFont)
      love.graphics.print("instructions",love.graphics.getWidth()/2 - largecalcFont:getWidth("INSTRUCTIONS")/2,50)
      love.graphics.setFont(xSmallCalcFont)
      for _,v in ipairs(instructComponents) do
        love.graphics.print(v[1],v[2],v[3])
      end
      love.graphics.rectangle("fill",instructComponents[6][2],instructionsYtable[1],xSmallCalcFont:getWidth(instructComponents[6][1]),4)
    end
    
    if (state == gamestates[6]) then
      love.graphics.setColor(0,0,0,1)
      love.graphics.setFont(largecalcFont)
      love.graphics.print("credits",love.graphics.getWidth()/2 - largecalcFont:getWidth("CREDITS")/2,50)
      love.graphics.setFont(xSmallCalcFont)
      for _,v in ipairs(creditComponents) do
        love.graphics.print(v[1],v[2],v[3])
      end
      love.graphics.rectangle("fill",creditComponents[6][2],creditsYtable[1],xSmallCalcFont:getWidth(creditComponents[6][1]),4)
    end
    
    if not (state == gamestates[1]) and not (state == gamestates[5]) and not (state == gamestates[6]) and not (state == gamestates[7]) and not (PAUSED == true) then
      --love.graphics.draw(backgrounds_table[1],0,0)
      love.graphics.draw(backCanvas,brickX,topBar.height)
      --love.graphics.draw(leftBarCanvas,0,topBar.y + topBar.height)
      -- Draw right bar canvas
      love.graphics.setColor(1,1,1,1)
      --love.graphics.draw(rightBarCanvas,love.graphics.getWidth() - (BRICK_SIZE * 4),topBar.y + topBar.height)
      love.graphics.draw(topBarCanvas,topBar.x,topBar.y)
      love.graphics.draw(bottomBarCanvas,topBar.x,love.graphics.getHeight() - bottomBarCanvas:getHeight())
    end
    -- Draw the top bar.
    --love.graphics.setBackgroundColor(1,1,1,1)
    
    if (PAUSED == true) then
      love.graphics.setColor(0,0,0,1)
      love.graphics.setFont(largecalcFont)
      for _,v in ipairs(pauseComponents) do
        love.graphics.print(v[1],v[2],v[3])
      end
      love.graphics.rectangle("fill",pauseComponents[selectionIndex][2],pauseYTable[selectionIndex],largecalcFont:getWidth(pauseComponents[selectionIndex][1]),4)
      love.graphics.setColor(1,1,1,1)
    end
  --end
  
  if (state == gamestates[7]) then
    love.graphics.setBackgroundColor(0,0,0,1)
    love.graphics.setFont(largecalcFont)
    love.graphics.setColor(1,1,1,textA)
    local ox,oy = largecalcFont:getWidth(texts[1]) * .5,largecalcFont:getHeight(texts[1]) * .5
    love.graphics.print(texts[1],textX + ox,textY + oy,0,scaleX,scaleY,ox,oy)
  end
  
  if not (state == gamestates[7]) then
    love.graphics.setColor(0,0,0,backA)
    love.graphics.rectangle("fill",0,0,love.graphics.getWidth(),love.graphics.getHeight())
    love.graphics.setColor(1,1,1,1)
  end
  
end
